
#define VERSION "200411"

#define DIRECTORY  "C:\\_MikroC\\_MesProjets_MikroC\\_16F1619_TEST_HEF\\HEF_Mkroe_Ex"
#define PROJECT "Flash_test_MikroE_rev1.mcppi"
#define SOURCE "Flash_test_MikroE_rev1"
#define Langage "MikroC 7.6.0"
#define PROCESSOR "PIC 16F1619 "
#define DEVICES  "no "
#define EEPROM  "No....ihex"
#define POWER_SUPPLY  " 3.3 to 5V"
#define OSCILLATEUR_INTERNE
#define FOSC "16.0"  // MHz
#define BAUD "19200"  // UART1

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Beep 7

sbit Led_Rouge at LATA.B4;
sbit Led_Rouge_Dir at TRISA.B4;
sbit SQA at LATC.B5;
sbit SQA_Dir at TRISC.B5;
sbit Led_Bleue at LATC5_bit;
sbit HEF_Ecrit at PORTC.B1;
sbit HEF_Ecrit_Dir at TRISC.B1;


char i = 0;
unsigned int addr, data_, dataAR[32];
char txtUart[60];


char TEXTE[80];
char *p1=&TEXTE[0];

void Init_Hardware(void) ;
void strConstRamCpy(unsigned char *dest, const code char *source);
void Init_Hardware(void) ;
void CRLF1(void);
void UART1_Write_CText(const char *txt);
void Config_PPS(void);


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

#define Print UART1_Write_Text


void CRLF1()
{
 UART1_Remappable_Write(CR);
 UART1_Remappable_Write(LF);
}

void CPrint(const char *txt)
 {
   while (*txt)
      UART1_Remappable_Write(*txt++);
      Delay_us(5);
}

void Config_PPS(void)
{
  Unlock_IOLOCK();
    RC5PPS=0;
    RA4PPS=0;
 // USART1   RX, TX
   // ---------- Peripheral PIN and EUSART configuration ----------------------
   // PPS_Mapping(char rp_num, char input_output, char funct_name);
  //   PPS_Mapping(RB7, _OUTPUT, _TX_CK);
  //   PPS_Mapping(RB5, _INPUT, _RXPPS);
   // use  direct
    RB5PPS = 0x0D;      //  RX RB5
    RB7PPS= 0x12;       // TX RB7

   // --- I2C ----------------------
   // PPS_Mapping(RB4 , _OUTPUT, _SDA);
   // PPS_Mapping(RB6 , _OUTPUT, _SCK_SCL);   // Sets RB6 SCL I2C

  // TABLE 13-2: AVAILABLE PORTS FOR OUTPUT BY PERIPHERAL
  //   REGISTER 13-2: RxyPPS: PIN Rxy OUTPUT SOURCE SELECTION REGISTER
  //  bit 7-5=0   bit 4-0 RxyPPS<4:0>: Pin Rxy Output Source Selection bits
    RB6PPS = 0x10; // 0b00010000; // 16 RB6->MSSP:SCL
    RB4PPS = 0x11; //0b00010001; // 17  RB4->MSSP:SDA;
  // TABLE 13-1: PPS INPUT REGISTER RESET VALUES
  // SPI and I2C clock SSPCLKPPS RB6
   SSPCLKPPS = 0x0E;   //RB6->MSSP:SCL;
   // SPI and I2C data SSPDATPPS RB4
   SSPDATPPS = 0x0C;   //RB4->MSSP:SDA;
    RC5PPS=0;
    RA4PPS=0;
  Lock_IOLOCK();
}


 void Init_Hardware()
{
  //REGISTER 6-1: BORCON: BROWN-OUT RESET CONTROL REGISTER
  BORCON.SBOREN=0;
  // no analog on PORT A,B,C
  ANSELA=0;
  TRISA=0xFF;
  Led_Rouge_Dir=0;  // RA4
  Led_Rouge=0;

  ANSELB=0;
  TRISB=0b11111111;
   // I2C pin must be set as input and Open drain
  WPUB=0 ;// Weak pull up on port B RB4-RB7 :  0=DISABLED
  //  1=open drain    0=push pull output
  ODCONB.B4 = 1;  // 1=open drain  output   SDA
  ODCONB.B6 = 1; // 1=open drain output   SCL
  ODCONB.B5 = 0;  // 0=push pull   input  RX
  ODCONB.B7 = 0;  // 0=push pull output   TX

  SLRCONB=0xF0; // 1 = Port pin slew rate is limited
  INLVLB=00; //1 = ST input used for PORT reads and interrupt-on-change

  ANSELC=0;
  TRISC=0b11011111;    // RC5 output SDA et Led Bleue
  WPUC=0b00100010 ;// Weak pull up on port C RC5 and RC1
//  HEF_Ecrit_Dir=1; //RC1;
  ODCONC.B5 = 1; //
//  SQA_Dir=0;   //RC5        SQA  led Bleue tire au +Vcc
//  SQA=0;

  // page 230
  OPTION_REG.nWPUEN =0;  //  0= Weak pull-ups are enabled by individual WPUx latch values   1=disable WPUP

 }


 void Init_Fosc(void)
 {
 // internal FOSC
  OSCCON=0;
 // 16 MHZ
   OSCCON.IRCF3=1;
    OSCCON.IRCF2=1;
     OSCCON.IRCF1=1;
      OSCCON.IRCF0=1;
// 1x = Internal oscillator block
   OSCCON.SCS1=1;
   OSCTUNE=0;
   }

void main() {
 
 /*
  ANSELA = 0;        // Configure AN pins as digital
  ANSELB = 0;
  ANSELC = 0;
  C1ON_bit = 0;                       // Disable comparators
  C2ON_bit = 0;
  TRISB = 0;                          // Set PORTB as output
  PORTB = 0;                          // Initial PORTB value
  TRISC = 0;
  PORTC = 0;                          // Initial PORTC value
  
   Unlock_IOLOCK();
     PPS_Mapping_NoLock(_RC6, _OUTPUT, 18);
     PPS_Mapping_NoLock(_RC7, _INPUT, _RXPPS);
   Lock_IOLOCK();
  Delay_ms(100);
 */
  *p1=&TEXTE[0];
  Init_Fosc(); // internal FOSC  1111 =16 MHz HF
   // SCS FOSC; SPLLEN disabled; IRCF 16MHz_HF;
   // OSCCON = 0x78;
   // OSCTUNE = 00;
    Init_Hardware() ;
    Config_PPS();
  
  UART1_Remappable_Init(19200);
  CPrint("\r\n FLASH TEST (HEF) 16F1619 \r\n");
  Delay_ms(100);
  
  addr = 0x1F80;
 strConstRamCpy(p1,"ABC123456DEFGH0123456789ABCDEFGHIJKLMNOPQ");
 CPrint(" Ecrit 32 data  partir de 0x1F80\r\n");

  for (i = 0; i < 32; i++)
  {
    dataAR[i] =*(p1+i);
  }
  FLASH_Write(addr, &dataAR[0]);
  Delay_ms(100);

 CPrint(" Ecrit 32 data  partir de 0x1FA0\r\n");

  for (i = 0; i < 32; i++)
  {
    dataAR[i] = addr+32+i;
  }
  FLASH_Write(addr+32, &dataAR[0]);
  Delay_ms(100);
  
  CPrint(" Ecrit 32 data  partir de 0x1FC0\r\n");
  for (i = 0; i < 32; i++){
    dataAR[i] = addr+64+i;
  }
  FLASH_Write(addr+64, &dataAR[0]);
  Delay_ms(100);

 CPrint(" Ecrit 32 data  partir de 0x1FE0\r\n");
  for (i = 0; i < 32; i++)
  {
    dataAR[i] = addr+96+i;
  }
  FLASH_Write(addr+96, &dataAR[0]);
  Delay_ms(100);

  CPrint(" Relecture de 128 bytes  partir de 0x1F80\r\n");
  for (i = 0; i < 128; i++)
  {
    data_ = FLASH_Read(addr++);
    Delay_us(10);
    WordToHex(data_, txtUart);
    Print(txtUart);
    CRLF1();
    //UART1_Remappable_Write_Text(txtUart);
    //UART1_Remappable_Write(13);
    //UART1_Remappable_Write(10);
    Delay_ms(50);
  }
}

/*

 FLASH TEST (HEF) 16F1619
 Ecrit 32 data  partir de 0x1F80
 Ecrit 32 data  partir de 0x1FA0
 Ecrit 32 data  partir de 0x1FC0
 Ecrit 32 data  partir de 0x1FE0
 Relecture de 128 bytes  partir de 0x1F80
0041
0042
0043
0031
0032
0033
0034
0035
0036
0044
0045
0046
0047
0048
0030
0031
0032
0033
0034
0035
0036
0037
0038
0039
0041
0042
0043
0044
0045
0046
0047
0048
1FA0
1FA1
1FA2
1FA3
1FA4
1FA5
1FA6
1FA7
1FA8
1FA9
1FAA
1FAB
1FAC
1FAD
1FAE
1FAF
1FB0
1FB1
1FB2
1FB3
1FB4
1FB5
1FB6
1FB7
1FB8
1FB9
1FBA
1FBB
1FBC
1FBD
1FBE
1FBF
1FC0
1FC1
1FC2
1FC3
1FC4
1FC5
1FC6
1FC7
1FC8
1FC9
1FCA
1FCB
1FCC
1FCD
1FCE
1FCF
1FD0
1FD1
1FD2
1FD3
1FD4
1FD5
1FD6
1FD7
1FD8
1FD9
1FDA
1FDB
1FDC
1FDD
1FDE
1FDF
1FE0
1FE1
1FE2
1FE3
1FE4
1FE5
1FE6
1FE7
1FE8
1FE9
1FEA
1FEB
1FEC
1FED
1FEE
1FEF
1FF0
1FF1
1FF2
1FF3
1FF4
1FF5
1FF6
1FF7
1FF8
1FF9
1FFA
1FFB
1FFC
1FFD
1FFE
1FFF



*/